---
title: Dialog
---
import DocCardList from '@theme/DocCardList';

The current dialog is handled via different common dialog components: ASR, NLU, Dialog Manager, and TTS.
The current ASR is Vosk ASR. THe NLU is done via a Rasa pipeline and components. The Dialog Manager is Simple Flexdiam and the TTS is done via pyttsx3.


```yaml
modules:
  vosk_asr:
    module_info: !name:vosk_asr.modules.asr_simulator.AsrSimulator
    mean_frequency_step: 10
    # module_info: !name:vosk_asr.modules.vosk_asr.VoskAsr
  rasa_nlu:
    module_info: !name:nlu_rasa.modules.rasa_nlu_module.RasaNluModule
  basic_tts:
    module_info: !name:basic_tts.modules.basic_tts.BasicTts
  simple_flexdiam:
    module_info: !name:simple_flexdiam.modules.simple_flexdiam_module.SimpleFlexdiam
    flow_handler:
      flow_handler_class: !name:simple_flexdiam.modules.issue_flow_handler.issue_flow_handler.IssueFlowHandler
      root_issue: !name:simple_flexdiam.modules.std.issues.root_issue.RootIssue
      shadow_root_issues:
        - !name:simple_flexdiam.modules.std.issues.greet_issue.GreetIssue
        - !name:simple_flexdiam.modules.std.issues.how_are_you_issue.HowAreYouIssue
        - !name:simple_flexdiam.modules.std.issues.repeat_issue.RepeatIssue
      entry_point_finder: !name:simple_flexdiam.modules.issue_flow_handler.simple_entry_point_finder.SimpleEntryPointFinder
```

## Install Dialog Modules

Besides the general [_aaambos_ installation](/docs), you need to install:
* ASR (Speech Recognition) Module: [Vosk ASR](https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_vosk_asr)
* NLU (Language Understanding) Module: [Rasa NLU](https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_rasa_nlu)
* TTS (Text-To-Speech) Module: [Basic TTS](https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_basic_tts)
* DM (Dialog Manager) Module: [Simple FlexDiam](https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_simple_flexdiam)

You can either clone each repo and install it (described in the `README.md`s).
If you do not want to change the code of the modules directly and changing the configs is enough, you can install the modules directly:

:::info
Assumes you already [installed _aaambos_](/docs) with a conda environment named `aaambos`. And that you are on a Linux-based OS.
:::

```bash title="conda activate aaambos"
sudo apt install espeak ffmpeg libespeak1 libportaudio2
pip install 'rasa[spacy]'
python3 -m spacy download de_core_news_sm
rasa telemetry disable

pip install vosk_asr@git+https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_vosk_asr@main
pip install nlu_rasa@git+https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_rasa_nlu@main
pip install basic_tts@git+https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_basic_tts@main
pip install simple_flexdiam@git+https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_simple_flexdiam@main
```

### Setup New Addons for FlexDiam
Inside a new pkg you can define new issues and observers. Then, you can add them via the configs to your architecture (`arch_config`)

To start creating simple FlexDiam Addons use the _aaambos_ create command with the `flexdiam_pkg` config:
```bash title="conda activate aaambos"
aaambos create pkg -v flexdiam_pkg
cd simple_flexdiam_pkg_PROJECT_NAME
pip install -e . --no-deps
```
Follow the questions. A lot of the default values are probably suitable (Except:
- [1/32] name,
- _maybe 2 - 4_,
- [6/32] your project name,
- [25/32] gitlab group and project path, and
- [27/32] description)

If you have a cloned simpe flexdiam repo installed locally, you might want to remove the requirement in `setup.py` or call `pip install -e . --no-deps` instead.

You find the `arch_config` and `run_config` in the `configs` folder if you did not deny the _config_ question in the questionnaire.

### Run an Agent with Dialog Abilities
:::info
If you did not setup new addons by creating an aaambos / flexdiam pkg you need to download the `arch_config` and `run_config` from the [SimpleFlexdiam repo](https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_simple_flexdiam/-/tree/main/simple_flexdiam/configs?ref_type=heads).
:::

Check if a MQTT Broker is running (`nanomq start` in another terminal).
```bash title="conda activate aaambos"
aaambos run --run_config run_config.yml --arch_config arch_config.yml
```


<DocCardList />


